=== debian/changelog ===
yyjson (0.12.0+ds-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 14 Nov 2025 07:30:08 -0800

yyjson (0.12.0+ds-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * New upstream version 0.12.0+ds
  * d/symbols: Update newer symbols
  * d/copyright: Update year of copyright and delete removed file
  * d/patches: Update patch

 -- Andre Paiusco <debian@paiusco.org>  Sun, 14 Sep 2025 16:15:09 +0200

yyjson (0.10.0+ds-2) experimental; urgency=medium

  * Team upload.

  [ Derick William de Moraes Frias ]
  * d/control: bump standards-version to 4.7.2

  [ Maytham Alsudany ]
  * d/gbp.conf: Add ignore-branch

 -- Derick William de Moraes Frias <derick.william.frias@usp.br>  Wed, 11 Jun 2025 19:05:20 +0000
