=== debian/control ===
Source: yyjson
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Carlos Henrique Lima Melara <charlesmelara@riseup.net>
Uploaders: Hiago De Franco <hiagofranco@gmail.com>,
           Maytham Alsudany <maytha8thedev@gmail.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               cmake,
               doxygen <!nodoc>,
               graphviz <!nodoc>
Standards-Version: 4.7.2
Homepage: https://github.com/ibireme/yyjson
Vcs-Browser: https://salsa.debian.org/debian/yyjson
Vcs-Git: https://salsa.debian.org/debian/yyjson.git

Package: libyyjson-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libyyjson0 (= ${binary:Version}), ${misc:Depends}
Suggests: libyyjson-doc
Description: high performance JSON library written in ANSI C (development files)
 Some features of the library are:
 .
  - Fast: can read or write gigabytes per second JSON data on modern CPUs.
  - Portable: complies with ANSI C (C89) for cross-platform compatibility.
  - Strict: complies with RFC 8259 JSON standard, ensuring strict number format
    and UTF-8 validation.
  - Extendable: offers options to allow comments, trailing commas, NaN/Inf, and
    custom memory allocator.
  - Accuracy: can accurately read and write int64, uint64, and double numbers.
  - Flexible: supports unlimited JSON nesting levels, \u0000 characters, and non
    null-terminated strings.
  - Manipulation: supports querying and modifying using JSON Pointer, JSON Patch
    and JSON Merge Patch.
  - Developer-Friendly: easy integration with only one .h and one .c file.
 .
 This package contains the development files for libyyjson.

Package: libyyjson-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: high performance JSON library written in ANSI C (documentation)
 Some features of the library are:
 .
  - Fast: can read or write gigabytes per second JSON data on modern CPUs.
  - Portable: complies with ANSI C (C89) for cross-platform compatibility.
  - Strict: complies with RFC 8259 JSON standard, ensuring strict number format
    and UTF-8 validation.
  - Extendable: offers options to allow comments, trailing commas, NaN/Inf, and
    custom memory allocator.
  - Accuracy: can accurately read and write int64, uint64, and double numbers.
  - Flexible: supports unlimited JSON nesting levels, \u0000 characters, and non
    null-terminated strings.
  - Manipulation: supports querying and modifying using JSON Pointer, JSON Patch
    and JSON Merge Patch.
  - Developer-Friendly: easy integration with only one .h and one .c file.
 .
 This package contains the documentation files for libyyjson.

Package: libyyjson0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: high performance JSON library written in ANSI C
 Some features of the library are:
 .
  - Fast: can read or write gigabytes per second JSON data on modern CPUs.
  - Portable: complies with ANSI C (C89) for cross-platform compatibility.
  - Strict: complies with RFC 8259 JSON standard, ensuring strict number format
    and UTF-8 validation.
  - Extendable: offers options to allow comments, trailing commas, NaN/Inf, and
    custom memory allocator.
  - Accuracy: can accurately read and write int64, uint64, and double numbers.
  - Flexible: supports unlimited JSON nesting levels, \u0000 characters, and non
    null-terminated strings.
  - Manipulation: supports querying and modifying using JSON Pointer, JSON Patch
    and JSON Merge Patch.
  - Developer-Friendly: easy integration with only one .h and one .c file.
 .
 This package contains the shared library.
